{----------------------------------------------------------------}
{
{    Jogo do Alto e Baixo
{    Autor: Antonio Borges
{    Baseado num original de autor desconhecido, em linguagem C++
{    Em 2/3/2002
{
{    Revisado por Wendrill Aksenow Brando, com a colaborao do Chat GPT
{    Em 04/01/2025
{
{----------------------------------------------------------------}

program casino;
uses dvcrt, dvWin, sysUtils;
var
    initialMoney, oldInitial: longint;
    money: longint;
    oldMoney: longint;
    bet: longint; { Introduzido para limitar apostas }
    asd, dsa: integer;
    turns, oldTurns: integer;
    highLow: char;
    know: char;
    name, oldName: string;
    s: string;
    scorefile: text;
    error: integer;

const
    MAXMONEY = 1000000;
    cardName: array [1..13] of string[10] =
    ('s', '2', '3', '4', '5', '6', '7', '8', '9', '10', 'Valete', 'Dama', 'Rei');

label reiniciarJogo;

begin
    sintInic (0, '');
    sintFalaPont := false;

    textBackground (BLUE);
    sintWriteln ('Benvindo ao Cassino da Fortuna!');
    textBackground (BLACK);
    writeln;
    randomize;
    sintWriteln ('Ol, com quem tenho o prazer de jogar?');
    sintReadln (name);

reiniciarJogo:

    sintWriteln ('Com quanto dinheiro voc comea? (no mximo 30000)');
    sintReadln (s);
    if trim(s) = '' then s := '30000';
    val (s, money, error);
    if error <> 0 then money := 0;

    if (money > 30000) or (money < 1) then
    begin
        money := 30000;
        sintWriteln ('Eu s aceito entre 1 e 30000, so as regras da casa!');
    end;

    initialMoney := money;

    writeln;
    sintWriteln ('OK, vou lev-lo  mesa do jogo de Alto ou Baixo.');
    delay (2000);
    writeln;
    sintWrite ('Voc conhece as regras de Alto ou Baixo? ');
    know := readkey;
    sintWriteln (know);
    if upcase (know) <> 'N' then
        sintWriteln ('Muito bem, comearemos o jogo.')
    else
        begin
            sintWriteln ('Certo, eu ensino...');
            writeln;
            textColor (YELLOW);
            sintWriteln ('Voc tira uma carta, faz sua aposta, e tenta adivinhar a prxima.');
            sintWriteln ('Voc responder Alto (tecle apenas A) se achar que a prxima carta  maior,');
            sintWriteln ('ou ento Baixo (tecle apenas B) se achar que a prxima  menor.');
            sintWriteln ('O valor das cartas com um nmero  o prprio nmero.');
            sintWriteln ('s vale 1, valete vale 11, dama vale 12 e rei vale 13.');
            sintWriteln ('Se estiver certo ganha, caso contrrio perde!');
            sintWriteln ('O objetivo do jogo  atingir um milho de reais no menor nmero de jogadas.');
            { Informao sobre as novas regras }
            sintWriteln ('Nota: Quando estiver perto de alcanar 1 milho de reais,');
            sintWriteln (' o valor mximo da sua aposta ser ajustado automaticamente para evitar que voc ultrapasse este limite.');
            textColor (LIGHTGRAY);
        end;

    turns := 0;
    while (money < MAXMONEY) and (money > 0) do
    begin
        while keypressed do readkey;
        delay (1000);
        writeln;
        turns := turns + 1;

        textBackground (RED);
        sintWrite ('Rodada ');
        sintWriteInt (turns);
        writeln;
        textBackground (BLACK);
        writeln;

        asd := random(13) + 1;
        dsa := random(13) + 1;
        repeat
            sintWrite ('Voc tirou ');
            sintWriteln (cardName[asd]);
            sintWrite ('A prxima carta vai ser mais alta ou baixa? ');
            highLow := upcase (readkey);
            sintWriteln (highLow);
        until (highLow = 'A') or (highLow = 'B');

        repeat
            { Calcula o limite dinmico da aposta }
            if money + money > MAXMONEY then
                bet := MAXMONEY - money
            else
                bet := money;

            sintWrite ('Quanto dinheiro voc aposta? No mximo ');
            sintWriteInt (bet); { Limite atualizado dinmicamente }
            writeln;
            sintReadln (s);
            if trim (s) = '' then s := intToStr(bet);
            val (s, bet, error);
        until (error = 0) and (bet <= money) and (bet > 0) and (money + bet <= MAXMONEY);

        if ((highLow = 'A') and (asd < dsa)) or
           ((highLow = 'B') and (asd > dsa)) then
        begin
            sintWriteln ('Voc ganhou. A outra carta era ' + cardName[dsa]);
            money := money + bet;
        end
        else
        begin
            sintWriteln ('Voc perdeu. A outra carta era ' + cardName[dsa]);
            money := money - bet;
        end;

        sintWrite ('Voc tem agora ');
        sintWriteInt (money);
        sintWriteln (' reais.');
    end;

    { Lgica de verificao de recorde corrigida }
    if money >= MAXMONEY then
    begin
        assign (scorefile, 'recasino.txt');
        {$I-} reset (scoreFile);  {$I+}
        if ioresult = 0 then
        begin
            readln (scoreFile, oldInitial, oldMoney, oldTurns, oldName);
            close (scoreFile);
        end
        else
        begin
            oldInitial := 30000;
            oldMoney := 1000000; { Corrigido para o valor mximo possvel }
            oldTurns := 18; { Corrigido para refletir um nmero plausvel de rodadas }
            oldName := 'Pingim';
        end;

        writeln;
        sintWrite ('O recorde anterior era de ');
        sintWrite (oldName);
        sintWrite (' que comeou com ');
        sintWriteInt (oldInitial);
        sintWrite (' e conseguiu chegar a ');
        sintWriteInt (oldMoney);
        sintWrite (' reais em ');
        sintWriteInt (oldTurns);
        sintWrite (' jogadas.');
        writeln;

        if (money > oldMoney) or
           ((money = oldMoney) and (turns < oldTurns)) then
        begin
            rewrite (scoreFile);
            writeln (scoreFile, initialMoney, ' ', money, ' ', turns, ' ', name);
            close (scoreFile);

            writeln;
            textColor (YELLOW);
            sintWrite ('Novo recorde! ');
            sintWrite (name); { Corrigido para mostrar o nome do jogador em vez do valor acumulado } 
            textColor (LIGHTGRAY);
            writeln;
        end;

        sintWrite ('Voc conseguiu atingir o total de ');
        sintWriteInt (money);
        sintWrite (' reais em ');
        sintWriteInt (turns);
        sintWriteln (' jogadas.');
    end
    else
    begin
        writeln;
        sintWriteln ('Voc perdeu o jogo.');
    end;

    sintWrite ('Aperte Enter para jogar novamente ou ESC para terminar');
//    readln;
    know := readkey;
    if know <> ESC then goto reiniciarJogo;

    doneWinCrt;
end.
